javascript: 


var JSON;
if(!JSON){
JSON={};
}
(function(){
'use strict';
function f(n){
return n<10?'0'+n:n;
}
if(typeof Date.prototype.toJSON!=='function'){
Date.prototype.toJSON=function(key){
return isFinite(this.valueOf())
?this.getUTCFullYear()+'-'+
f(this.getUTCMonth()+1)+'-'+
f(this.getUTCDate())+'T'+
f(this.getUTCHours())+':'+
f(this.getUTCMinutes())+':'+
f(this.getUTCSeconds())+'Z'
:null;
};
String.prototype.toJSON=
Number.prototype.toJSON=
Boolean.prototype.toJSON=function(key){
return this.valueOf();
};
}
var cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
gap,
indent,
meta={
'\b':'\\b',
'\t':'\\t',
'\n':'\\n',
'\f':'\\f',
'\r':'\\r',
'"':'\\"',
'\\':'\\\\'
},
rep;
function quote(string){
escapable.lastIndex=0;
return escapable.test(string)?'"'+string.replace(escapable,function(a){
var c=meta[a];
return typeof c==='string'
?c
:'\\u'+('0000'+a.charCodeAt(0).toString(16)).slice(-4);
})+'"':'"'+string+'"';
}
function str(key,holder){
var i,
k,
v,
length,
mind=gap,
partial,
value=holder[key];
if(value&&typeof value==='object'&&
typeof value.toJSON==='function'){
value=value.toJSON(key);
}
if(typeof rep==='function'){
value=rep.call(holder,key,value);
}
switch(typeof value){
case'string':
return quote(value);
case'number':
return isFinite(value)?String(value):'null';
case'boolean':
case'null':
return String(value);
case'object':
if(!value){
return'null';
}
gap+=indent;
partial=[];
if(Object.prototype.toString.apply(value)==='[object Array]'){
length=value.length;
for(i=0;i<length;i+=1){
partial[i]=str(i,value)||'null';
}
v=partial.length===0
?'[]'
:gap
?'[\n'+gap+partial.join(',\n'+gap)+'\n'+mind+']'
:'['+partial.join(',')+']';
gap=mind;
return v;
}
if(rep&&typeof rep==='object'){
length=rep.length;
for(i=0;i<length;i+=1){
if(typeof rep[i]==='string'){
k=rep[i];
v=str(k,value);
if(v){
partial.push(quote(k)+(gap?': ':':')+v);
}
}
}
}else{
for(k in value){
if(Object.prototype.hasOwnProperty.call(value,k)){
v=str(k,value);
if(v){
partial.push(quote(k)+(gap?': ':':')+v);
}
}
}
}
v=partial.length===0
?'{}'
:gap
?'{\n'+gap+partial.join(',\n'+gap)+'\n'+mind+'}'
:'{'+partial.join(',')+'}';
gap=mind;
return v;
}
}
if(typeof JSON.stringify!=='function'){
JSON.stringify=function(value,replacer,space){
var i;
gap='';
indent='';
if(typeof space==='number'){
for(i=0;i<space;i+=1){
indent+=' ';
}
}else if(typeof space==='string'){
indent=space;
}
rep=replacer;
if(replacer&&typeof replacer!=='function'&&
(typeof replacer!=='object'||
typeof replacer.length!=='number')){
throw new Error('JSON.stringify');
}
return str('',{'':value});
};
}
if(typeof JSON.parse!=='function'){
JSON.parse=function(text,reviver){
var j;
function walk(holder,key){
var k,v,value=holder[key];
if(value&&typeof value==='object'){
for(k in value){
if(Object.prototype.hasOwnProperty.call(value,k)){
v=walk(value,k);
if(v!==undefined){
value[k]=v;
}else{
delete value[k];
}
}
}
}
return reviver.call(holder,key,value);
}
text=String(text);
cx.lastIndex=0;
if(cx.test(text)){
text=text.replace(cx,function(a){
return'\\u'+
('0000'+a.charCodeAt(0).toString(16)).slice(-4);
});
}
if(/^[\],:{}\s]*$/
.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,'@')
.replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,']')
.replace(/(?:^|:|,)(?:\s*\[)+/g,''))){
j=eval('('+text+')');
return typeof reviver==='function'
?walk({'':j},'')
:j;
}
throw new SyntaxError('JSON.parse');
};
}
}());



var loader = function() { 
	
        loader.callbacks = {};
          loader._TOKEN = "%s";
          
 		function _prepareMessage(request, callback, param1, param2, param3) {
          	obj = {};
          	obj.request = request;
          	obj.token = loader._TOKEN;
          	obj.parameters = [callback.toString()];
          	
          	toPush = [param1, param2, param3];
          	
          	for (var i = 0; i<toPush.length; i++) {
          		if (toPush[i] != null) {
          			obj.parameters.push(toPush[i]);
          		} else {
          			break;
          		}
          	}
          	
          	var message = JSON.stringify(obj);
          	console.log("prepared message: " + message);
          	return message;
          };
          
          function _handleMessageFromVApp(message) {
          		
                   var obj = JSON.parse(message, null);
                   
                    var callback = eval("(" + obj.parameters[0] + ")");
                    console.log("handle msg: "+obj.parameters[0]+":"+message);
                    callback(message);
          };
          
          function _callbacks(key, message) {
              console.log("Key: " + key + ", Message: " + message);
              console.log("callback is " + loader.callbacks[key]);
              loader.callbacks[key](message);
          };
         
          function _testFunction(message) {
              document.body.innerHTML = message;
              document.body.style.background = "white";
          };

          function _reflect(callback, info) {
             JSInterface.reflect(_prepareMessage("reflect", callback, info));
          };
          
          function _start(callback, info) {
              var message = _prepareMessage("start", callback, info);
              callback(JSInterface.start(message));
          };
          
          function _end(callback, result, complete, info) {
              var message = _prepareMessage("end", callback, result, complete, info);
              callback(JSInterface.end(message));
          };
          
          function _checkpoint(callback, info) {
             callback(JSInterface.checkpoint(_prepareMessage("checkpoint", callback, info)));
          };
          
          
		
          
          
          function _setReminder(callback, showID, shouldSet) {
             var key = showID + shouldSet;
             console.log("Key is " + key + "\n");
             loader.callbacks[key] = callback;
             console.log("Callback set.");
             JSInterface.setReminder(_prepareMessage("setReminder", callback, showID, shouldSet));
          };

          function _getReminder(callback, showID) {
            loader.callbacks[showId] = callback;
            JSInterface.getReminder(_prepareMessage("getReminder", callback, showID));
          };
          
          function _like(callback, objectID, shouldLike) {
          	 loader.callbacks[objectID + "like"] = callback;
             JSInterface.like(_prepareMessage("like", callback, objectID, shouldLike));
          };
          
          function _getUserInfo(callback) {
          	 loader.callbacks["getUserInfo"] = callback;
             JSInterface.getUserInfo(_prepareMessage("getUserInfo", callback));
          };
             
          function _dial(callback, phoneNumber) {
          	JSInterface.dial(_prepareMessage("dial", "", phoneNumber));
          };

		 
          
         
          
          function _playVideoWithFeedback(startcallback, buffercallback, finishcallback, url, showLeavingEarlyDialog) {
            JSInterface.playVideoWithFeedback(_prepareMessageForVideo("playvideowithfeedback", [startcallback, buffercallback, finishcallback], url, showLeavingEarlyDialog)); 
          }
          
          function _prepareMessageForVideo(request, callbacks, url, showLeavingEarlyDialog) {
            var completion = '';
              if (!(url === undefined)) {
                 completion = '"' + url + '"';
              }

              callbackstring = "";

              for(var i in callbacks) {
                var f = callbacks[i];
                cs = '"' + f.toString().replace(/\n/g,"") + '",';
                callbackstring = callbackstring + cs;
              } 

            completion = completion + ',"' + showLeavingEarlyDialog.toString() +  '"' + ' ] }';
            var message = '{"request": "' + request + '", "token" : "' + loader._TOKEN + '", "parameters": [ ' + callbackstring + completion;
            
            return message;
          }
          
          function _prepareMessageForArrayOfOrientations(request, callback, orientations) {
            var completion = '';

              callbackstring = "";

              for(var i in orientations) {
                var f = orientations[i];
                cs = '"' + f.toString().replace(/\n/g,"") + '",';
                callbackstring = callbackstring + cs;
              } 

            callbackstring = callbackstring.substring(0, callbackstring.length-1);

            completion = completion + ' ] }';
            return '{"request": "' + request + '", "token" : "' + loader._TOKEN + '", "parameters": [ ' + callbackstring + completion;
          }
          
   
   		  function _showModal(callback, title, points, content) {
            JSInterface.showModal(_prepareMessage("showmodal", callback, title, points, content));
          }

          function _browserGoBack(callback) {
            JSInterface.browserGoBack(_prepareMessage("browsergoback", callback));
          }

          function _browserGoForward(callback) {
            JSInterface.browserGoForward(_prepareMessage("browsergoforward", callback));
          }

          function _browserLoadPage(callback, urltoload) {
            JSInterface.browserLoadPage(_prepareMessage("browserloadpage", callback, urltoload));
          }

          function _setLeftButtonTitle(callback, title) {
            JSInterface.setDoneButtonTitle(_prepareMessage("setleftbuttontitle", callback, title));
          }
   
   		function _setTitleBarTitle(callback, title) {
            JSInterface.setTitleBarTitle(_prepareMessage("settitlebartitle", callback, title));
          }

          function _setTitleBarImages(callback, portraitimageurl, landscapeimageurl) {
            JSInterface.setTitleBarImage(_prepareMessage("settitlebarimages", callback, portraitimageurl, landscapeimageurl));
          }
          
          function _setDesiredOrientations(callback, orientations) {
            JSInterface.setDesiredOrientations(_prepareMessageForArrayOfOrientations("setdesiredorientations", callback, orientations))
          }
   
		  function _presentModalViewController(callback, url) {
			JSInterface.presentModalViewController(_prepareMessage("presentmodalviewcontroller", callback, url));
		  }
   
		  function _pushViewController(callback, url) {
			JSInterface.pushViewController(_prepareMessage("pushviewcontroller", callback, url));
		  }

		  function _postToFacebookOpenGraph(callback, message) {
			JSInterface.postToFacebookOpenGraph(_prepareMessage("posttofacebook", callback, message));
		  }
   
		  function _postToSocialNetwork(callback, defaultmessage, subtitle) {
			JSInterface.postToSocialNetwork(_prepareMessage("posttosocialnetworks", callback, defaultmessage, subtitle));
		  }
          
          function _allowToLeave(callback, enabled){
          	JSInterface.allowToLeave(_prepareMessage("allowtoleave", callback, enabled));
          }
   
          window.ViggleAdViewJavascriptBridge = {
              callbacks: _callbacks,
          	  testFunction: _testFunction,
              reflect: _reflect,
              start: _start,
              end: _end,
              checkpoint: _checkpoint,
              setReminder: _setReminder,
              getReminder: _getReminder,
              like: _like,
              getUserInfo: _getUserInfo,
              dial: _dial,
              playVideoWithFeedback: _playVideoWithFeedback,
              showModal: _showModal,
              browserGoBack: _browserGoBack,
              browserGoForward: _browserGoForward,
              browserLoadPage: _browserLoadPage,
            	  setLeftButtonTitle: _setLeftButtonTitle,
              setTitleBarImages:_setTitleBarImages,
              setTitleBarTitle: _setTitleBarTitle,
              setDesiredOrientations: _setDesiredOrientations,
              presentModalViewController: _presentModalViewController,
              pushViewController: _pushViewController,
              postToFacebookOpenGraph: _postToFacebookOpenGraph,
              postToSocialNetwork: _postToSocialNetwork,
              allowToLeave: _allowToLeave,
              handleMessageFromVApp: _handleMessageFromVApp
          };
          
          setTimeout(function() {
               var doc = document;
               var readyEvent = doc.createEvent('HTMLEvents');
               readyEvent.initEvent('ViggleAdViewJavascriptBridgeReady');
               doc.dispatchEvent(readyEvent);
          }, 0);
          
      }; 
      loader();